/*
 * File:   newmain_Miuva.c
 * Author: tatua
 *
 * Created on 18 de junio de 2020, 11:53 AM
 */
#define     RS  LATDbits.LATD5
#define     EN  LATDbits.LATD4
#define     D4  LATDbits.LATD0
#define     D5  LATDbits.LATD1
#define     D6  LATDbits.LATD2
#define     D7  LATDbits.LATD3
#define _XTAL_FREQ 48000000
#include <xc.h>
#include "lcd.h"
#include "stdio.h"
#pragma config PLLDIV = 2, CPUDIV = OSC1_PLL2, USBDIV = 2
#pragma config FOSC = HSPLL_HS, FCMEN = OFF, IESO = OFF
#pragma config PWRT = OFF, BOR = OFF, VREGEN = OFF
#pragma config WDT = OFF
#pragma config MCLRE = ON, LPT1OSC = OFF, PBADEN = OFF
#pragma config STVREN = ON, LVP = OFF, ICPRT = OFF, XINST = OFF

#define UMBRAL 4.2

void main(void) {
    int adc_high = 0;
    float voltaje = 0;
    char buffer[16];
    char buffer2[16];
    TRISD = 0x00;   //Conexiones de la LCD como salida
    Lcd_Init();
    TRISA = 0xFF;
    TRISB = 0x00;
    ADCON1 = 0x0E;
    ADCON0 = 0x00;
    ADCON2 = 0b00001110;
    ADCON0bits.ADON = 1;
    while(1){
        ADCON0bits.GO_DONE = 1;
        while(ADCON0bits.GO_DONE == 1){
        }
        adc_high = ADRESH;
        Lcd_Set_Cursor(1,1);
        sprintf(buffer,"ADC %u", adc_high);
        Lcd_Write_String(buffer);
        voltaje = adc_high * 5.0 / 255.0;
        Lcd_Set_Cursor(2,1);
        sprintf(buffer2,"V %f", voltaje);
        Lcd_Write_String(buffer2);
        __delay_ms(100);
        Lcd_Clear();
        if (voltaje > UMBRAL){
            LATBbits.LATB0 = 1;
        }
        else{
            LATBbits.LATB0 = 0;
        }
    }
    return;
}
